unit ConsoleForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, KclClassesMan, ToolWin, ImgList,
  KclDesignConsole, Menus, KclDesignPopupMenu, StdActns, ActnList, KclDesigner,
  DfmLoader, StdCtrls, Buttons, KclDesignActions;


type
  TFormConsole = class(TForm)
    Panel1: TPanel;                                                          
    Panel2: TPanel;
    KclCompPalleteTab1: TKclCompPalleteTab;
    PageScroller1: TPageScroller;
    KclCompPalleteToolBar1: TKclCompPalleteToolBar;
    DesignCenter: TKclDesignCenter;
    DefDesignCompPopupMenu: TKclDefDesignCompPopupMenu;
    ClassesImageList: TKclClassesImageList;
    ActionList1: TActionList;
    ImageList1: TImageList;
    FileOpen1: TFileOpen;
    FileSaveAs1: TFileSaveAs;
    FileExit1: TFileExit;
    ActionDesign: TAction;
    ActionNewDesignForm: TAction;
    ActionCloseForm: TAction;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ActionSaveForm: TAction;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolBar2: TToolBar;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    KclDesignEditCopy1: TKclDesignEditCopy;
    KclDesignEditCut1: TKclDesignEditCut;
    KclDesignEditPaste1: TKclDesignEditPaste;
    KclDesignEditSelAll1: TKclDesignEditSelAll;
    KclDesignEditDelSel1: TKclDesignEditDelSel;
    KclDesignSelCtrlBringToFront1: TKclDesignSelCtrlBringToFront;
    KclDesignSelCtrlSendToBack1: TKclDesignSelCtrlSendToBack;
    KclDesignSelCtrlFlipSelChildren1: TKclDesignSelCtrlFlipSelChildren;
    KclDesignSelCtrlFlipAllChildren1: TKclDesignSelCtrlFlipAllChildren;
    KclDesignSelCtrlPositionAlign1: TKclDesignSelCtrlPositionAlign;
    KclDesignSelCtrlPositionSize1: TKclDesignSelCtrlPositionSize;
    KclDesignSelCtrlPositionScale1: TKclDesignSelCtrlPositionScale;
    ActionDemoTip: TAction;
    ActionAbout: TAction;
    ToolButton6: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Close1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    SelectAll1: TMenuItem;
    N2: TMenuItem;
    BringtoFront1: TMenuItem;
    SendtoBack1: TMenuItem;
    Align1: TMenuItem;
    Scale1: TMenuItem;
    Scale2: TMenuItem;
    FlipChildren1: TMenuItem;
    All1: TMenuItem;
    Selected1: TMenuItem;
    Help1: TMenuItem;
    DemoTip1: TMenuItem;
    N3: TMenuItem;
    About1: TMenuItem;
    ToolButton15: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure KclCompPalleteTab1Change(Sender: TObject);
    procedure ActionDesignExecute(Sender: TObject);
    procedure ActionNewDesignFormExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FileSaveAs1Accept(Sender: TObject);
    procedure FileOpen1Accept(Sender: TObject);
    procedure ActionSaveFormExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActionCloseFormExecute(Sender: TObject);
    procedure ActionList1Update(Action: TBasicAction;
      var Handled: Boolean);
    procedure ActionAboutExecute(Sender: TObject);
    procedure ActionDemoTipExecute(Sender: TObject);
  private
    { Private declarations }
    FFormDesign: TForm;
    FFormFileName: string;
    procedure OpenUI;
    procedure CloseUI;
    procedure CreateDesignManager(AOwnerForm: TCustomForm);
    procedure NewDesignForm;
    function CloseDesignForm(ConfirmIfDirty: Boolean = True): Boolean;
    procedure OpenFormFile(AFileName: string);
    procedure SaveFormToFile(AFileName: string);

    procedure SetFormDesignState(AForm: TCustomForm; AValue: Boolean);
  public
    { Public declarations }
    property FormDesign: TForm read FFormDesign write FFormDesign;
  end;

var
  FormConsole: TFormConsole;

implementation

uses
  ObjInspectForm, CompTreeViewForm, DesignForm, DfmUtils,
  DesignEnvInit, DefRegister, DefParentForm, AboutForm, Unit2;

{$R *.dfm}

procedure TFormConsole.FormCreate(Sender: TObject);
begin
  DesignEnvInit.DesignClassList.Images := ClassesImageList;
  KclCompPalleteToolBar1.ClassList := DesignEnvInit.DesignClassList;
end;

procedure TFormConsole.KclCompPalleteTab1Change(Sender: TObject);
begin
  PageScroller1.Update;
end;

procedure TFormConsole.OpenUI;
begin
  FormObjInspec.Show;
  FormCompTreeView.Show;
  //FormDesign.Show;
end;

procedure TFormConsole.CloseUI;
begin
end;

procedure TFormConsole.ActionDesignExecute(Sender: TObject);
begin
  if ActionDesign.Checked then
  begin
    OpenUI;
    SetFormDesignState(FormDesign, True);
    DesignCenter.DesignManager.Designing := True;
  end
  else begin
    DesignCenter.DesignManager.Designing := False;
    SetFormDesignState(FormDesign, False);
    CloseUI;
  end;
end;

procedure TFormConsole.NewDesignForm;
var
  F: TForm;
  M: TKclDesignManager;
begin
  F := TForm.Create(FormDefParent);
  F.AutoScroll := False;
  F.Parent := nil;
  F.Name := 'Form1';
  F.Top := FormDesignDef.Top;
  F.Left := FormDesignDef.Left;
  F.Width := FormDesignDef.Width;
  F.Height := FormDesignDef.Height;
  F.Show;
  FFormFileName := '';
  Self.FormDesign := F;
  CreateDesignManager(F);
  DesignCenter.Dirty := True;
  FormObjInspec.MqyObjInspector1.OwnerComponent := FormDesign; 
end;

procedure TFormConsole.ActionNewDesignFormExecute(Sender: TObject);
begin
  NewDesignForm;
  ActionDesign.Checked := True;
  ActionDesignExecute(Self);
end;

procedure TFormConsole.FormShow(Sender: TObject);
begin
  FormCompTreeView.KclCompTreeView1.ClassList := DesignEnvInit.DesignClassList;
end;

procedure TFormConsole.FileSaveAs1Accept(Sender: TObject);
var
  FN: string;
  DoSave: Boolean;
begin
  if not Assigned(FormDesign) then Exit;
  FN := FileSaveAs1.Dialog.FileName;
  DoSave := True;
  if FileExists(FN) then
    if MessageDlg('File already exists. Overwrite it?', mtConfirmation, [mbYes, mbNo], 0) = mrNo then
      DoSave := False;
  if DoSave then
  begin
    SaveFormToFile(FN);
  end;
end;

procedure TFormConsole.CreateDesignManager(AOwnerForm: TCustomForm);
var
  M: TKclDesignManager;
begin
  M := TKclDesignManager.Create(AOwnerForm);
  M.DesignStage := AOwnerForm;
  DesignCenter.DesignManager := M;
end;

procedure TFormConsole.OpenFormFile(AFileName: string);
var
  C: TComponent;
  F: TForm;                        
begin
  C := DfmLoader.ReadDFM(AFileName, nil);
  FFormFileName := AFileName;
  if C is TForm then
  begin
    F := TForm(C);
    FormDefParent.InsertComponent(F);
    F.Parent := nil;    
    F.Show;
    //SetFormDesignState(F, True);
    Self.FormDesign := F;
    CreateDesignManager(F);
    DesignCenter.Dirty := False;
    FormObjInspec.MqyObjInspector1.OwnerComponent := FormDesign;
  end;
end;

procedure TFormConsole.FileOpen1Accept(Sender: TObject);
var
  DoOpen: Boolean;
begin
  if Assigned(FormDesign) then
    DoOpen := CloseDesignForm
  else
    DoOpen := True;
  if DoOpen then
  begin
    OpenFormFile(FileOpen1.Dialog.FileName);
    ActionDesign.Checked := True;
    ActionDesignExecute(Self);
  end;
end;

function TFormConsole.CloseDesignForm(ConfirmIfDirty: Boolean): Boolean;
var
  R: Integer;
begin
  if not Assigned(FormDesign) then Exit;
  if DesignCenter.Dirty and ConfirmIfDirty then
  begin
    R := MessageDlg('Form has been modified. Save changes?', mtConfirmation, [mbYes, mbNo, mbCancel], 0);
    if R = mrYes then
      SaveFormToFile(FFormFileName)
    else if R = mrCancel then
    begin
      Result := False;
      Exit;
    end;
  end;
  SetFormDesignState(FormDesign, False);
  DesignCenter.DesignManager.Designing := False;
  FormDesign.Close;
  CloseUI;
  FreeAndNil(FFormDesign);
  FFormFileName := '';
  Result := True;  
end;

procedure TFormConsole.SaveFormToFile(AFileName: string);
var
  CA: TClassArray;
begin
  if not Assigned(FormDesign) then Exit;
  if Trim(AFileName) = '' then
  begin
    FileSaveAs1.Execute;
  end
  else begin
    SetLength(CA, 1);
    CA[0] := TKclDesignManager;
    DfmLoader.WriteDFM(AFileName, FormDesign, False, CA);
    DesignCenter.Dirty := False;
    FFormFileName := AFileName;
  end;
end;

procedure TFormConsole.ActionSaveFormExecute(Sender: TObject);
begin
  SaveFormToFile(FFormFileName);
end;

procedure TFormConsole.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if not CloseDesignForm then
    Action := caNone;
end;

procedure TFormConsole.SetFormDesignState(AForm: TCustomForm;
  AValue: Boolean);
begin
  FormDefParent.SetDesignState(AValue);
end;

procedure TFormConsole.ActionCloseFormExecute(Sender: TObject);
begin
  Self.CloseDesignForm(True);
end;

procedure TFormConsole.ActionList1Update(Action: TBasicAction;
  var Handled: Boolean);
var
  IsFormLoaded: Boolean;
  S: string;
begin
  IsFormLoaded := Assigned(FormDesign);
  ActionCloseForm.Enabled := IsFormLoaded;
  ActionDesign.Enabled := IsFormLoaded;
  FileSaveAs1.Enabled := IsFormLoaded;  
  ActionSaveForm.Enabled := IsFormLoaded and DesignCenter.Dirty;
  if IsFormLoaded then
  begin
    S := 'DFM Builder - ' + FormDesign.Name;
    if DesignCenter.Dirty then
      S := S + ' [*]';
  end
  else
    S := 'DFM Builder';
  Caption := S;
end;

procedure TFormConsole.ActionAboutExecute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TFormConsole.ActionDemoTipExecute(Sender: TObject);
begin
  FormReadme.Show;
end;

initialization
  RegisterClass(TForm);
  RegisterClass(TKclDesignManager);
  DefRegister.RegisterPropEditors;
  DefRegister.RegisterComponentEditors;
  DefRegister.RegisterAttribEditors;
end.
